********************************************************************************
*This program uses bisection method to solve for the equilibrium deposit rate
*taking the inputs from the program "bank_foc" and using the year variable in the data
*Author: Jiaqi Li
*Created on 20 April, 2022
		
		
				
cap program drop eqm_solver
program  eqm_solver, rclass
	//model = nest_d_cbdc or nest_c_cbdc
	//cf_year = year in which CBDC is issued
	syntax [, lowerbound(string)  upperbound(string)  tol(string)  model(string)  cf_year(string)]
	
	//tempvar lower upper  midpoint  f1 f2 prod
	scalar lower = `lowerbound'
	scalar upper = `upperbound'
	
	while  (abs(lower - upper) >= `tol') {

        scalar midpoint = (lower + upper)/2
		bank_foc, dep_rate(lower) model(`model')
		scalar f1 = r(foc`cf_year')        /*save output from function bank_foc*/
		bank_foc, dep_rate(midpoint) model(`model')
		scalar f2 = r(foc`cf_year')        /*save output from function bank_foc*/
		
        scalar prod = f1*f2
        if prod > `tol' {
            scalar lower = midpoint
		}
        if prod < `tol' { 
            scalar upper = midpoint
		}
	}
	return scalar new_dep_rate = midpoint
	
end
	

	
	
	